----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 	Dimitrios Porlidas
-- 
-- Create Date:    05:58:07 01/17/2016 
-- Design Name:    AddMulCoun
-- Module Name:    main - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity main is
port (
			CLK: in STD_LOGIC;
			SW0: in STD_LOGIC;
			SW1: in STD_LOGIC;
			SW2: in STD_LOGIC;
			SW3: in STD_LOGIC;
			BTNW: in STD_LOGIC;
			BTNE: in STD_LOGIC;
			BTNU: in STD_LOGIC;
			BTND: in STD_LOGIC;
			SEL: in STD_LOGIC_VECTOR (3 downto 0);
			LED: out STD_LOGIC_VECTOR (7 downto 0);
			sum: buffer STD_LOGIC_VECTOR (2 downto 0);
			prod: buffer STD_LOGIC_VECTOR (3 downto 0);
			count: buffer STD_LOGIC_VECTOR (7 downto 0)
		);
end main;

architecture Behavioral of main is

component counter
port	(
			CLK: in STD_LOGIC;
			BTNW: in STD_LOGIC;
			BTNE: in STD_LOGIC;
			BTNU: in STD_LOGIC;
			BTND: in STD_LOGIC;
			count: buffer STD_LOGIC_VECTOR (7 downto 0)
		);
end component;

component adder
port	(
			CLK: in STD_LOGIC;
			SW0: in STD_LOGIC;
			SW1: in STD_LOGIC;
			SW2: in STD_LOGIC;
			SW3: in STD_LOGIC;
			BTNW: in STD_LOGIC;
			BTNE: in STD_LOGIC;
			sum: buffer STD_LOGIC_VECTOR (2 downto 0)
		);
end component;

component multip
port	(
			CLK: in STD_LOGIC;
			SW0: in STD_LOGIC;
			SW1: in STD_LOGIC;
			SW2: in STD_LOGIC;
			SW3: in STD_LOGIC;
			BTNW: in STD_LOGIC;
			BTNE: in STD_LOGIC;
			prod: buffer STD_LOGIC_VECTOR (3 downto 0)
		);
end component;

	signal result: STD_LOGIC_VECTOR (7 downto 0);

begin

	counter1: counter port map (CLK, BTNW, BTNE, BTNU, BTND, count);
	adder1: adder port map (CLK, SW0, SW1, SW2, SW3, BTNW, BTNE, sum);
	multip1: multip port map (CLK, SW0, SW1, SW2, SW3, BTNW, BTNE, prod);

	LED <= result;

process

begin
	
	if SEL="1111" then result <= "11111111";
		elsif SEL="1110" then result (7 downto 4) <= "0000"; result (3 downto 0) <= prod;
		elsif SEL="1101" then result (7 downto 3) <= "00000"; result (2 downto 0) <= sum;
		elsif SEL="1011" then result <= count;
		elsif SEL="0111" then result <= "00000000";		
	end if;
	
end process;

end Behavioral;


